function  out = cp_kalman_extended(in)

u = in(1);
y = in(2:3);

Ts = in(4);
rr = in(5:6);
qq = in(7:8);

H = [1,0,0,0;0,0,1,0];

Q = 10*diag([1e-10, qq(1), 1e-10, qq(2)]);
R = 100*diag([rr(1), rr(2)]);

x_hat_z1 = in(9:12);
P_k_1 =  reshape( in(13:28), [4,4] );


m = 0.1;
L = 1;
g = 9.81;
M = 1;
d1 = 1;
d2 = 0.5;

% % % % Kalman Update

% update state prediction
dot_x = x_hat_z1(2);
theta = x_hat_z1(3);
dot_theta = x_hat_z1(4);

f_1 = dot_x ;
f_2 = (u  + m*L*dot_theta^2 * sin(theta) - m*g*cos(theta) *  sin(theta) ) / ( M+m-m* cos(theta)^2 )  - d1*dot_x;
f_3 = dot_theta;
f_4 = (g*sin( theta ) -  cos( theta )*f_2 ) / L - d2*dot_theta;
f = [f_1,f_2,f_3,f_4]';

x_k_1 = x_hat_z1 + Ts*f ;


% obtain matrices A,B by linearization
dot_x = x_k_1(2);
theta = x_k_1(3);
dot_theta = x_k_1(4);

f_23 = (g*m*sin(theta)^2 - g*m*cos(theta)^2 + L*dot_theta^2*m*cos(theta))/(- m*cos(theta)^2 + M + m) - (2*m*cos(theta)*sin(theta)*(L*m*sin(theta)*dot_theta^2 + u - g*m*cos(theta)*sin(theta)))/(- m*cos(theta)^2 + M + m)^2;
f_24 = (2*L*dot_theta*m*sin(theta))/(- m*cos(theta)^2 + M + m);
f_42 =  (d1*cos(theta))/L;
f_43 =  -(cos(theta)*((g*m*sin(theta)^2 - g*m*cos(theta)^2 + L*dot_theta^2*m*cos(theta))/(- m*cos(theta)^2 + M + m) - (2*m*cos(theta)*sin(theta)*(L*m*sin(theta)*dot_theta^2 + u - g*m*cos(theta)*sin(theta)))/(- m*cos(theta)^2 + M + m)^2) + sin(theta)*(d1*dot_x - (L*m*sin(theta)*dot_theta^2 + u - g*m*cos(theta)*sin(theta))/(- m*cos(theta)^2 + M + m)) - g*cos(theta))/L;
f_44 =  - d2 - (2*dot_theta*m*cos(theta)*sin(theta))/(- m*cos(theta)^2 + M + m);

A = [0,1,0,0 ; 0,-d1,f_23, f_24; 0,0,0,1; 0, f_42, f_43, f_44 ] ;

B = [0;
    1/(- m*cos(theta)^2 + M + m);
    0 ;
    -cos(theta)/(L*(- m*cos(theta)^2 + M + m))  ]; 

Ad = expm(A*Ts);
%Bd = pinv(A)*(Ad-eye(4))*B;

% prediction covariance
P_k = Ad*P_k_1*Ad'+Q;

z = y - H*x_k_1;
S = R + H*P_k*H';

K = P_k*H'/S;

x_k = x_k_1 + K*z;
P_k = (eye(4)-K*H)*P_k;

out = [ x_k' , P_k(1,:) , P_k(2,:) , P_k(3,:) , P_k(4,:) ];