
run('cartpole_main.m')

open_system('cartpoleF')
load_system('cartpoleF')

in = Simulink.SimulationInput('cartpoleF');

T_end = 20;

t = (0:0.1:T_end)';
obs_noise1 = sqrt(0.0002)*ones(size(t));
obs_noise2 = sqrt(0.0002)*ones(size(t));
proc_noise1 = sqrt(q1)*ones(size(t));
proc_noise2 = sqrt(q2)*ones(size(t));

ts_1 = timeseries(obs_noise1,t);
ts_2 = timeseries(obs_noise2,t);
ts_3 = timeseries(proc_noise1,t);
ts_4 = timeseries(proc_noise2,t);


out = sim(in);

time = out.simout.Time;
output = out.simout.Data;

%Plotting model
figure,
fontsize = 18;
tiledlayout(4,1)
nexttile
plot(time, output(:,1), 'LineWidth',3)
title('x','FontSize',fontsize )
nexttile
plot(time, output(:,2), 'LineWidth',3)
title('v_x','FontSize',fontsize )
nexttile
plot(time, output(:,3), 'LineWidth',3)
title('theta','FontSize',fontsize )
nexttile
plot(time, output(:,4), 'LineWidth',3)
title('v_{theta}','FontSize',fontsize )

%% Monitoring property with Moonlight


%Generate a monitor object from the script fine multiple_spec.mls 
%this object is an implementation of ScriptLoader class, please 
%refer to the doc of this class for more details (ex. write in console 
%"doc ScriptLoader" ) please, open multiple_spec.mls 
moonlightScript = ScriptLoader.loadFromFile("spec_cartpole.mls");

prop_name = "Spec1";
moonlightScript.setMinMaxDomain();
quantitativeMonitor= moonlightScript.getMonitor(prop_name);
qMonitorResult  = quantitativeMonitor.monitor(time, output); 


%Plotting result...
figure,
fontsize = 16;
tiledlayout(2,1)
nexttile
plot(time, output(:,3), 'LineWidth',3)
title('theta','FontSize',fontsize )
nexttile
plot(qMonitorResult(:,1),qMonitorResult(:,2), '-r', 'LineWidth',3)
hold on
title('eventually{globally {|theta| < 0.5 )}} ','FontSize',fontsize )

