function rob = rob_fc(xx)

T_end = 20;
Tsim = 1e-3;
Ts =1e-2;

n_sim = 1;

data = zeros(T_end/Tsim+1,4,n_sim);

for i= 1:n_sim

    const = rand(4,1) * 2e-4;
    r1 = xx;
    r2 = const(2);
    q1 = const(3);
    q2 = const(4);

    out = sim('cartpoleF');
    
    time = out.simout.Time;
    output = out.simout.Data;
    
    %% Monitoring property with Moonlight


    %Generate a monitor object from the script fine multiple_spec.mls 
    %this object is an implementation of ScriptLoader class, please 
    %refer to the doc of this class for more details (ex. write in console 
    %"doc ScriptLoader" ) please, open multiple_spec.mls 
    moonlightScript = ScriptLoader.loadFromFile("spec_cartpole.mls");

    prop_name = "Spec1";
    moonlightScript.setMinMaxDomain();
    quantitativeMonitor= moonlightScript.getMonitor(prop_name);
    qMonitorResult  = quantitativeMonitor.monitor(time, output); 

    rob = qMonitorResult(1,2);


end
end

